//-----------------------------------------------------------------------------
#ifndef DeviceHandlerH
#define DeviceHandlerH DeviceHandlerH
//-----------------------------------------------------------------------------
#include <mvIMPACT_CPP/mvIMPACT_acquire.h>

class DeviceConfigureFrame;

//-----------------------------------------------------------------------------
class DeviceHandler
//-----------------------------------------------------------------------------
{
	bool boSetIDSupported_;
protected:
	mvIMPACT::acquire::Device* pDev_;
	DeviceConfigureFrame* pParent_;
public:
	DeviceHandler( mvIMPACT::acquire::Device* pDev, bool boSetIDSupported = false ) : boSetIDSupported_(boSetIDSupported), pDev_(pDev) {}
	virtual ~DeviceHandler() {}
	void AttachParent( DeviceConfigureFrame* pParent ) { pParent_ = pParent; }
	virtual bool SupportsFirmwareUpdate( void ) const = 0;
	virtual bool SupportsKernelDriverUpdate( bool& /*boNewerDriverAvailable*/, std::string& /*kernelDriverName*/ ) { return false; }
	bool SupportsSetID( void ) const { return boSetIDSupported_; }
	virtual int UpdateFirmware( void );
	virtual int UpdateKernelDriver( void );
	//-----------------------------------------------------------------------------
	enum TUpdateResult
	//-----------------------------------------------------------------------------
	{
		urOperationSuccessful,
		urFeatureUnsupported,
		urOperationCanceled,
		urInvalidFileSelection,
		urFileIOError,
		urDeviceAccessError
	};

};

#endif // DeviceHandlerH
